drama.shaders = {};
drama.shaders["noise"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump float seconds;\nuniform lowp float intensity;\nuniform lowp float noiseColor;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);\n	lowp float a = front.a;\n	\n	if (a != 0.0)\n		front.rgb /= a;\n	\n	mediump float seconds_mod = mod(seconds, 10.0);	mediump vec3 noise = vec3(fract(sin(dot(vTex.xy, vec2(12.9898,78.233)) + seconds_mod) * 43758.5453),\n							  fract(sin(dot(vTex.yx, vec2(12.9898,-78.233)) + seconds_mod) * 43758.5453),\n							  fract(sin(dot(vTex.xy, vec2(-12.9898,-78.233)) + seconds_mod) * 43758.5453));\n	noise = mix(vec3(noise.r), noise, noiseColor);\n	front.rgb += (noise * intensity) - (intensity / 2.0);\n	front.rgb *= a;\n	\n	gl_FragColor = front;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: true,
	animated: false,
	parameters: [["intensity",0,1],["noiseColor",0,1]]
};

drama.shaders["warplayout"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\nuniform mediump vec2 srcOriginStart;\nuniform mediump vec2 srcOriginEnd;\nuniform mediump vec2 layoutStart;\nuniform mediump vec2 layoutEnd;\nuniform mediump float seconds;\nuniform mediump vec2 pixelSize;\nuniform mediump float layerScale;\n\nuniform mediump float periodX;\nuniform mediump float periodY;\nuniform mediump float ampX;\nuniform mediump float ampY;\nuniform mediump float speedX;\nuniform mediump float speedY;\n\nvoid main(void)\n{\n	mediump float _2pi = 2.0 * 3.14159265359;	mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;\n	mediump vec2 n = ((vTex - srcOriginStart) / srcOriginSize);\n	mediump vec2 l = mix(layoutStart, layoutEnd, n);	mediump vec2 p = vTex;\n	p.x += cos((l.y / periodY) * _2pi + seconds * speedY * _2pi) * ampY * pixelSize.x * layerScale;\n	p.y += sin((l.x / periodX) * _2pi + seconds * speedX * _2pi) * ampX * pixelSize.y * layerScale;	p = clamp(p, min(srcStart, srcEnd), max(srcStart, srcEnd));\n	\n	gl_FragColor = texture2D(samplerFront, p);\n}\n",
	extendBoxHorizontal: 30,
	extendBoxVertical: 30,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: true,
	parameters: [["periodX",0,0],["periodY",0,0],["ampX",0,0],["ampY",0,0],["speedX",0,0],["speedY",0,0]]
};

drama.shaders["warpripple"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcOriginStart;\nuniform mediump vec2 srcOriginEnd;\nuniform mediump float seconds;\nuniform mediump vec2 pixelSize;\n\nuniform mediump float freq;\nuniform mediump float amp;\nuniform mediump float speed;\n\nconst mediump float PI = 3.1415926;\n\nvoid main(void)\n{\n	mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;\n	mediump vec2 tex = (vTex - srcOriginStart) / srcOriginSize;\n	tex = tex * 2.0 - 1.0;\n		\n	mediump float d = length(tex);\n	mediump float a = atan(tex.y, tex.x);\n	\n	d += sin((d * 2.0 * PI) * freq / (pixelSize.x * 750.0) + (seconds * speed)) * amp * (pixelSize.x * 750.0);\n	\n	tex.x = cos(a) * d;\n	tex.y = sin(a) * d;\n	\n	tex = (tex + 1.0) / 2.0;\n	tex = clamp(tex, 0.0, 1.0);\n	tex = tex * srcOriginSize + srcOriginStart;\n	\n	gl_FragColor = texture2D(samplerFront, tex);\n}\n",
	extendBoxHorizontal: 50,
	extendBoxVertical: 50,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: true,
	parameters: [["freq",0,0],["amp",0,1],["speed",0,0]]
};
